package poids;

import java.awt.*;
import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.applet.*;
import java.text.DecimalFormat;


public class poids extends Applet implements AdjustmentListener, ItemListener
{  

protected Checkbox terreMer, terreMontagne, lune, soleil, mercure, venus, mars, jupiter, saturne, uranus, neptune, pluton, parametrable;
protected Checkbox astres[] = {terreMer, terreMontagne, lune, soleil, mercure, venus, mars, jupiter, saturne, uranus, neptune, pluton, parametrable};
protected String nomAstres[] = {"Terre_mer", "Terre_alt", "Lune", "Soleil", "Mercure", "Venus", "Mars", "Jupiter", 
	                            "Saturne", "Uranus", "Neptune", "Pluton", "Parametrable"};
protected double gAstres[] = {9.806, 9.781, 1.62, 273, 3.7, 8.93, 3.72, 25.9, 11.28, 11.5, 10.98, 0.402, 0.0}; 
protected Label lpterreMer, lpterreMontagne, lplune, lpsoleil, lpmercure, lpvenus, lpmars, lpjupiter, lpsaturne, lpuranus, lpneptune, lppluton, lpparametrable;
protected Label poidsNewton[] = {lpterreMer, lpterreMontagne, lplune, lpsoleil, lpmercure, lpvenus, lpmars, lpjupiter, lpsaturne, lpuranus, lpneptune, lppluton, lpparametrable};
protected Label lcterreMer, lcterreMontagne, lclune, lcsoleil, lcmercure, lcvenus, lcmars, lcjupiter, lcsaturne, lcuranus, lcneptune, lcpluton, lcparametrable;
protected Label compaPoids[] = {lcterreMer, lcterreMontagne, lclune, lcsoleil, lcmercure, lcvenus, lcmars, lcjupiter, lcsaturne, lcuranus, lcneptune, lcpluton, lcparametrable}	;
final int debutIncRayon = 5; // incrementation initiale du scrollbar rayon parametrable
protected double valMasseParMin = Math.pow(10D, 24.0D);
protected double valRayonParMin = Math.pow(10D, 3.0D);
protected double valMassePar = valMasseParMin;
protected double valRayonPar = valRayonParMin + (debutIncRayon * 500);
protected CheckboxGroup groupeACocher = new CheckboxGroup();
protected Checkbox select, selectVoid;
protected Panel tabPanel;
static boolean cocherTous = true;
protected Scrollbar choixMasse, masseParam, rayonParam;
protected Label masseTexte, titleGraph, labelMasse, labelRayon;
protected GraphCanvas graphC;
protected Image graph;
protected Graphics g;
final static int valMasseMax = 300;
static double poidsMax; 
DecimalFormat df = new DecimalFormat("#######0.00");
DecimalFormat dfs = new DecimalFormat("#######0.0");

   
public void init() 
{
    for (int i=0; i<nomAstres.length; i++)
        nomAstres[i] = Messages.get(nomAstres[i]);
    Panel mainPanel = new Panel(new BorderLayout());
	GridBagConstraints c = new GridBagConstraints();
	c.insets = new Insets(0,0,0,0);
	Panel dialoguePanel = new Panel(new FlowLayout());
	dialoguePanel.setBackground(new Color(218,201,172));
	Panel massePanel = new Panel(new GridBagLayout());
	choixMasse = new Scrollbar(Scrollbar.HORIZONTAL, 0, 10, 0, (valMasseMax + 10));
    choixMasse.setValue(valMasseMax);                    	
	choixMasse.addAdjustmentListener(this);
	masseTexte = new Label(" " + Messages.get("masse_de") + " " + choixMasse.getValue() + " kg");
    select = new Checkbox(Messages.get("Tous_les_astres"),groupeACocher,false);
    select.setForeground(Color.red);
    select.addItemListener(this);
    selectVoid = new Checkbox("",groupeACocher,true);
    c.anchor = GridBagConstraints.CENTER;
    c.gridx = 0;
    c.gridy = 0;
    massePanel.add(masseTexte,c);
    c.gridy = 1;
    c.ipadx = 80;
    massePanel.add(choixMasse,c);
    c.gridy = 2;
    c.insets = new Insets(7,0,0,0);
    c.ipadx = 0;
    massePanel.add(select,c);
    Panel astresPanel = new Panel(new GridBagLayout());
    c.insets = new Insets(0,0,0,0);
    c.anchor = GridBagConstraints.WEST;
	c.ipadx = 2;
	int col=-1;
	for (int i=0; i<nbAstres(); i++) {
        astres[i] = new Checkbox(nomAstres[i], true);
        astres[i].addItemListener(this);
        if (i == 12) astres[i].setForeground(new Color(127,111,85)); // Parametrable
        else astres[i].setForeground(Color.black);
		if ((i % 3)==0) 
	    	col++;
        c.gridy = (i % 3);
        c.gridx = col;
        astresPanel.add(astres[i],c);
    }
	c.fill = 2;
	c.gridy = 1;
    masseParam = new Scrollbar(Scrollbar.HORIZONTAL, 0, 10, 0, 232);
    masseParam.addAdjustmentListener(this);
    astresPanel.add(masseParam,c);
    c.gridy = 2;
    rayonParam = new Scrollbar(Scrollbar.HORIZONTAL, 0, 10, 0, 108);
    rayonParam.setValue(debutIncRayon);
    rayonParam.addAdjustmentListener(this);
    astresPanel.add(rayonParam,c);	
    c.gridy = 0;
	c.gridx = 5;
    Label labexp = new Label(Messages.get("Masse_et_Rayon"));
    labexp.setForeground(new Color(127,111,85));
	astresPanel.add(labexp,c);
	c.gridy = 1;
    labelMasse = new Label(" " + Messages.get("abrev_masse") + " : " + joliFormattage(valMassePar) + " kg");
    labelMasse.setForeground(new Color(127,111,85));
    labelMasse.setFont(new Font(getFont().getName(), 0, 11));
    astresPanel.add(labelMasse,c);
	c.gridy = 2;
    labelRayon = new Label(" " + Messages.get("abrev_rayon") + " : " + joliFormattage(valRayonPar) + " km");
    labelRayon.setForeground(new Color(127,111,85));
    labelRayon.setFont(new Font(getFont().getName(), 0, 11));
    astresPanel.add(labelRayon,c);
    astres[0].setEnabled(false);
    astres[3].setState(false);
   	dialoguePanel.add(massePanel);
   	dialoguePanel.add(new Label("  "));
    dialoguePanel.add(astresPanel);
	reactgParam();
   	tabPanel = new Panel(new BorderLayout());
   	Panel tab = creerTab();
   	tabPanel.add(tab, BorderLayout.NORTH);
   	Panel graphPanel = new Panel(new BorderLayout());
   	graphC = new GraphCanvas(350, 350);
   	creerGraph();
   	titleGraph = new Label(" " + Messages.get("Poids_pour_masse") + " " + Integer.toString(choixMasse.getValue()) + " kg");
   	titleGraph.setFont(new Font(getFont().getName(), 0, 11));
   	titleGraph.setForeground(Color.gray);
   	titleGraph.setAlignment(1);
   	graphPanel.add(titleGraph, BorderLayout.CENTER);
   	graphPanel.add(graphC, BorderLayout.SOUTH);
   	mainPanel.add(dialoguePanel, BorderLayout.NORTH);
   	mainPanel.add(tabPanel, BorderLayout.WEST);
   	mainPanel.add(new Label(""), BorderLayout.CENTER);
   	mainPanel.add(graphPanel, BorderLayout.EAST);
   	add(mainPanel);
    majGraph();
    validate();
}

   
public void adjustmentValueChanged(AdjustmentEvent adjustmentevent)
{
    java.awt.Adjustable adjustable = adjustmentevent.getAdjustable();
    if(adjustable == choixMasse)
    {
        masseTexte.setText(" " + Messages.get("masse_de") + " " + Integer.toString(adjustmentevent.getValue()) + " kg");
       	titleGraph.setText(" " + Messages.get("Poids_pour_masse") + " " + Integer.toString(adjustmentevent.getValue()) + " kg");
    }
    if(adjustable == masseParam)
    {
    	double valTemp = valMasseParMin + (adjustmentevent.getValue() * 4.5 * Math.pow(10D, 24.0D));
        if(valTemp != valMassePar)
        {
        	valMassePar = valTemp;
        	labelMasse.setText(" M. : " + joliFormattage(valMassePar) + " kg");
        	reactgParam();
        }
    }
    if(adjustable == rayonParam)
    {
    	double valTemp = valRayonParMin + (adjustmentevent.getValue() * 500);
        if(valTemp != valRayonPar)
        {
        	valRayonPar = valTemp;
        	labelRayon.setText(" R. : " + joliFormattage(valRayonPar) + " km");
        	reactgParam();
        }
    }
    majTab();
    majGraph();
    validate();    
}

public void reactgParam() {
	gAstres[12] = (valMassePar * 0.0000000000667D) / (Math.pow(1000*valRayonPar,2));
}


public void itemStateChanged(ItemEvent itemevent)
{
    Object source = itemevent.getSource();
    if (source == select) {
        for (int i=1; i<nbAstres(); i++) {
            astres[i].setState(cocherTous); 
        }
	    select.setState(false);
	    selectVoid.setState(true);
    }   	
    if (nbAstresCoches()==(astres.length-1)) {
        cocherTous = false;
        select.setLabel(Messages.get("Terre_seule"));
    }
    else {
        cocherTous = true;
        select.setLabel(Messages.get("Tous_les_astres"));
    }
	tabPanel.removeAll();
	tabPanel.add(creerTab(), BorderLayout.NORTH);
    majGraph();
    validate();
}

   
protected void creerGraph()
{
    graph = createImage(350, 350);
    g = graph.getGraphics();
}

   
protected void majGraph()
{
   	g.setFont(new Font(getFont().getName(), 1, 11));
    g.setColor(new Color(229,229,239));
    g.fillRect(0, 0, 350, 350);    
    g.setColor(new Color(212,212,224));
    g.drawLine(15, 15, 340, 15);
    g.drawLine(12, 95, 340, 95);
    g.drawLine(12, 175, 340, 175);
    g.drawLine(12, 255, 340, 255);
    g.setColor(Color.black);
    g.drawRect(0, 0, 350, 350);
    g.setColor(Color.gray);
    g.drawLine(15, 15, 15, 335);
    g.drawLine(15, 15, 13, 18);
    g.drawLine(15, 15, 17, 18);
    g.drawLine(15, 335, 345, 335);
    g.setColor(Color.black);
    g.drawString("0", 5, 338);
    g.drawString(Long.toString(Math.round(poidsMax)) + " N.", 4, 12);
    int abscisse = 0 ;
    int pas = (25 - nbAstresCoches());
    if (!astres[1].getState()) pas--;
    for (int i=0; i<nbAstres(); i++) {
        if (i!=1 && astres[i].getState()) {
            abscisse += (2*pas);
            double poids = gAstres[i]*choixMasse.getValue();
            int hauteur = (int)(Math.round(320*(poids/poidsMax)));
            g.setColor (Color.black);
            g.drawString(nomAstres[i].substring(0,2), abscisse+((int)(pas/4)), 347);
            g.setColor (new Color(160,181,234)); 
            g.fill3DRect(abscisse,335-hauteur,pas+2,hauteur,true);
		}
	}
    graphC.updateImage(graph);
}


protected Panel creerTab()
{
    Panel result = new Panel(new GridBagLayout()); 
    Label text;
    GridBagConstraints c = new GridBagConstraints();
    c.anchor = GridBagConstraints.NORTHWEST;
    c.fill = 1;
    c.insets = new Insets(23,1,0,0);
    c.gridx = 0;
    c.gridy = 0;
    text = new Label(" " + Messages.get("Astres") + " ");  
    text.setForeground(Color.white);
    text.setBackground(Color.black);
    text.setAlignment(1);
    result.add(text, c);
    c.gridx = 1;
    text = new Label(" " + Messages.get("Poids") + " ");  
    text.setForeground(Color.white);
    text.setBackground(Color.black);
    text.setAlignment(1);
    result.add(text, c);
    c.gridx = 2;
    text = new Label("- " + Messages.get("Comparer_Terre") + " -");  
    text.setForeground(Color.white);
    text.setBackground(Color.black);
    text.setAlignment(1);
    result.add(text, c);
    c.insets = new Insets(1,1,0,0);
    poidsMax = 0;
    for (int i=0; i<nbAstres(); i++) {
        if (astres[i].getState()) {
            text = new Label(nomAstres[i]); 
            text.setBackground(new Color(160,181,234));
            text.setAlignment(1);
            c.gridx = 0;
            c.gridy ++;
            result.add(text, c);
            double maxpoids = gAstres[i]*valMasseMax;        	  
            if (maxpoids>=poidsMax) {
            	poidsMax=maxpoids;            	
            }
            double poids = gAstres[i]*choixMasse.getValue();
       	    double rapport = gAstres[i]/gAstres[0];        	 
            if (poids>90000) {
                poidsNewton[i] = new Label(joliFormattage(poids));
           	    compaPoids[i] = new Label(dfs.format(rapport) + " " + Messages.get("fois_eq") + " " + dfs.format(rapport*choixMasse.getValue()) + " kg)");
            }
            else {
            	poidsNewton[i] = new Label(df.format(poids));
           	    compaPoids[i] = new Label(df.format(rapport) + " " + Messages.get("fois_eq") + " " + df.format(rapport*choixMasse.getValue()) + " kg)");
            }
            poidsNewton[i].setBackground(new Color(179,193,239));
            poidsNewton[i].setAlignment(1);
            c.gridx = 1;
            result.add(poidsNewton[i], c);
       	    compaPoids[i].setBackground(new Color(160,181,234));
       	    compaPoids[i].setAlignment(1);
            c.gridx = 2;
            result.add(compaPoids[i], c);
        }
    }
   	return result;
}

   
protected void majTab()
{
   	poidsMax = 0;
	for (int i=0; i<nbAstres(); i++) {
        if (astres[i].getState()) {
         	double maxpoids = gAstres[i]*valMasseMax;
            if (maxpoids>=poidsMax) 
                poidsMax=maxpoids;
            double poids = gAstres[i]*choixMasse.getValue();
        	double rapport = gAstres[i]/gAstres[0];              
            if (poids>90000) { 
            	poidsNewton[i].setText(joliFormattage(poids));
            	compaPoids[i].setText(df.format(rapport) + " " + Messages.get("fois"));
            }
            else {
            	poidsNewton[i].setText(df.format(poids));
            	compaPoids[i].setText(df.format(rapport) + " " + Messages.get("fois_eq") + " " + df.format(rapport*choixMasse.getValue()) + " kg)");
            }
        }
    }
}
   
   
public int nbAstresCoches() {
    int nb = 0;
    for (int i=1;i<nbAstres();i++) {
   	    if (astres[i].getState())
   	        nb++; 
    } 
    return nb;
}

   
public int nbAstres() {
    return (astres.length);
}


public static String joliFormattage(double d)
{
    int i = 2;
    byte byte0 = 2;
    if (d == 0.0D)
        return "0";
    String s = "" + d;
    if ("Infinity".equals(s) || "-Infinity".equals(s) || "NaN".equals(s))
        return "" + d;
    String s1;
    if(d >= 0.0D) {
        s1 = "";
    } 
    else {
        d = -d;
        s1 = "-";
    }
    int j = (int)Math.floor(Math.log(d) / Math.log(10D));
    double d1 = Math.pow(10D, i);
    double d2 = d / Math.pow(10D, j);
    d2 = Math.rint(d2 * d1) / d1;
    if(d2 >= 10D) {
        j++;
        d2 = d / Math.pow(10D, j);
        d2 = Math.rint(d2 * d1) / d1;
    }
    String s2 = "";
    int k = (int)Math.floor(d2);
    s2 = s2 + k + ".";
    for(int l = 0; l < i - 1; l++)
    {
        d2 = (d2 - (double)k) * 10D;
        double d3 = Math.pow(10D, i - l);
        d2 = Math.rint(d2 * d1) / d1;
        k = (int)Math.floor(d2);
        s2 = s2 + k;
    }
    d2 = (d2 - (double)k) * 10D;
    k = (int)Math.round(d2);
    s2 = s2 + k;
    for(char c = s2.charAt(s2.length() - 1); c == '0'; c = s2.charAt(s2.length() - 1))
        s2 = s2.substring(0, s2.length() - 1);
    if(j != 0)
        if(j > 0 && j < byte0) {
            String s3 = s2.substring(0, 1);
            if(s2.length() - 2 < j) {
                if(s2.length() > 2)
                    s3 = s3 + s2.substring(2, s2.length());
                for(int i1 = 0; i1 < j - (s2.length() - 2); i1++)
                    s3 = s3 + '0';
            } 
            else
	            if(s2.length() < j + 2)
	                s3 = s3 + s2.substring(2);
	            else
	                s3 = s3 + s2.substring(2, j + 2) + "." + s2.substring(j + 2);
            s2 = s3;
        } 
        else
	        if(j < 0 && j > -byte0) {
	            String s4 = "0.";
	            for(int j1 = 0; j1 < -j - 1; j1++)
	                s4 = s4 + '0';
	            s2 = s4 + s2.charAt(0) + s2.substring(2);
	        }
	        else {
	            s2 = s2 + "E" + j;
	        }
    if(s2.charAt(s2.length() - 1) == '.')
        s2 = s2.substring(0, s2.length() - 1);
    s2 = s1 + s2;
    return s2;
}


public void destroy()
{  
	g.dispose();
}

}
